import java.awt.event.*;
import org.gjt.sp.jedit.*;
import java.awt.*;
import javax.swing.text.*;
import org.gjt.sp.util.*;
import java.io.*;

class AppendToBufferAction implements ActionListener
{
  private JEditCommanderTable theTable;
  private Buffer buffer;
  private ActionEvent event;
  
  public AppendToBufferAction()
  {
    this.theTable = null;
    this.buffer = null;
    this.event = null;
    
    actionPerformed(event);
  }
  
  public AppendToBufferAction(JEditCommanderTable table, Buffer b, 
    ActionEvent e)
  {
    this.theTable = table;
    this.buffer = b;
    this.event = e;
    
    actionPerformed(event);
  }
  
  public void actionPerformed(final java.awt.event.ActionEvent p1)
  {
    JEditCommanderTableModel model = theTable.getTableModel();
    JEditCommanderFile[] files = model.getCurrentFiles();
    int[] selected = theTable.getSelectedRows();
    
    if (selected.length < 1)
    {
      Toolkit.getDefaultToolkit().beep();
      return;
    }
    
    for (int i = 0; i < selected.length; i++)
    { 
      JEditCommanderFile theFile = files[selected[i]];
      if (theFile.getFile().isDirectory() == true)
        continue;
      
      BufferedReader fr = null;
      StringBuffer sbuf = new StringBuffer("");
      int ch = 0;
      try
      {
        fr = new BufferedReader(new FileReader(theFile.getFile()));
        while ((ch = fr.read()) != -1)
        {
          sbuf.append((char) ch);
        }
        fr.close();
      }
      catch (IOException ioex)
      {
        Log.log(Log.DEBUG, null, ioex.getMessage());
        continue;
      }
      
      Log.log(Log.DEBUG, null, "[JEDIT COMMANDER] Performing append of file "
        + theFile.getFilePath() + " to buffer " + buffer.toString());
      
      String text = sbuf.toString();
      
      if (text.length() < 1)
      {
         Log.log(Log.DEBUG, null, "[JEDIT COMMANDER] File " + theFile.getFilePath() + 
          " contains no text");
        continue;
      }
      
      int insertPosition = 0;
      if (buffer.getLength() > 0)
        insertPosition = buffer.getLength() - 1;
      
      try
      {
        buffer.insertString(insertPosition, text, null);
      }
      catch (BadLocationException blex)
      {
        Log.log(Log.DEBUG, null, "[JEDIT COMMANDER] Could not insert text " +
          text + " into buffer " + buffer.toString() + " at position " + 
          String.valueOf(insertPosition));
        continue;
      } 
    } // for
  }
}