import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.table.*;
import org.gjt.sp.util.*;

class ChangeDirAction implements ActionListener
{
	private File newDir;
	private JEditCommanderTable table;
	private boolean goDown;

	public ChangeDirAction()
	{
		newDir = null;
		table = null;
		goDown = true;
	}

	public ChangeDirAction(File directory, JEditCommanderTable table)
		throws IOException
	{
		if (!directory.isDirectory())
			throw new IOException(directory.getPath() + " is not a directory!");

		this.newDir = directory;
		this.table = table;
	}

	public void actionPerformed(ActionEvent event)
	{
		boolean doFilter = false;
                if (FileFiltering.filteringEnabled == true)
                {
                    doFilter = FileFiltering.createFilter(
                        JEditCommanderToolBar.filterBox.getText());
                }
                
                JEditCommanderTableModel model = table.getTableModel();

		if (goDown == true)
			newDir = JEditCommanderPlugin.leftDirectory.getParentFile();

		if (goDown == true && JEditCommanderFileHandler.isRoot(
			JEditCommanderPlugin.leftDirectory))
		{
			int lastIndex = model.getRowCount() - 1;
			if (lastIndex < 0)
				lastIndex = 0;
			model.setCurrentFiles(null);
			model.fireTableRowsDeleted(0, lastIndex);

			JEditCommanderFile[] newFiles =
				JEditCommanderFileHandler.transformToCommanderFiles(
				File.listRoots());
                        if (JEditCommanderFileHandler.sortType > -1)
                          JEditCommanderFileHandler.sort(newFiles);
			model.setCurrentFiles(newFiles);
			model.fireTableRowsInserted(0, newFiles.length - 1);

			JEditCommanderSplitPane.leftDirField.setText("ROOT");
                        JEditCommanderToolBar.rootSwitchBox.updateForDir(this.newDir.getPath());
			return;
		}

		JEditCommanderPlugin.leftDirectory = newDir;
		Log.log(Log.DEBUG, null, "leftDirectory: " +
			JEditCommanderPlugin.leftDirectory.getPath());

		int lastIndex = model.getRowCount() - 1;
		if (lastIndex < 0)
			lastIndex = 0;
		model.setCurrentFiles(null);
		model.fireTableRowsDeleted(0, lastIndex);

		JEditCommanderFile[] newFiles = JEditCommanderFileHandler.getFiles(newDir);
                if (JEditCommanderFileHandler.sortType > -1)
                          JEditCommanderFileHandler.sort(newFiles);
                if (doFilter == true)
                {
                    newFiles = FileFiltering.getFilesMatchingFilter(newFiles,
                        FileFiltering.prefix, FileFiltering.suffix);
                }        
		model.setCurrentFiles(newFiles);
		model.fireTableRowsInserted(0, newFiles.length - 1);

		JEditCommanderSplitPane.leftDirField.setText(newDir.getPath());
                JEditCommanderSplitPane.theBox.setText("");
                JEditCommanderToolBar.rootSwitchBox.updateForDir(
                    JEditCommanderPlugin.leftDirectory.getPath());
	}

	public File getDirectory()
	{
		return this.newDir;
	}

	public void setDirectory(File newDir) throws IOException
	{
		if (!newDir.isDirectory())
			throw new IOException(newDir.getPath() + " is not a directory!");

		this.newDir = newDir;
	}

	public JEditCommanderTable getTable()
	{
		return this.table;
	}

	public void setTable(JEditCommanderTable theTable)
	{
		this.table = theTable;
	}

	public boolean goDown()
	{
		return this.goDown;
	}

	public void setGoDown(boolean goDown)
	{
		this.goDown = goDown;
	}
}