import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import org.gjt.sp.jedit.*;
import java.io.*;

class CopyDialog extends JEditCommanderDialog
{
        private JTextField dirField;
        private CopyAction cpAction;

        public CopyDialog()
        {
                this.setModal(true);
                this.setTitle("Copy");
                
                this.getContentPane().setLayout(new BorderLayout());
                this.getContentPane().add(new JLabel("Please select destination directory:"),
                        BorderLayout.NORTH);
                
                JPanel middlePane = new JPanel();
                dirField = new JTextField(25);
                middlePane.add(dirField);
                JButton browseBtn = new JButton("Browse...");
                browseBtn.addActionListener(new BrowseFileAction());
                middlePane.add(browseBtn);
                this.getContentPane().add(middlePane, BorderLayout.CENTER);
                
                JPanel bottomPane = new JPanel(new GridLayout(1,0));
                JButton copyBtn = new JButton("Copy");
                copyBtn.addActionListener(new DoCopyAction());
                JButton cancelBtn = new JButton("Cancel");
                cancelBtn.addActionListener(new CancelCopyAction());
                bottomPane.add(copyBtn);
                bottomPane.add(cancelBtn);
                this.getContentPane().add(bottomPane, BorderLayout.SOUTH);
                
                this.pack();
                GUIUtilities.loadGeometry(this, "jeditcom-copy-dialog");
                
                this.addWindowListener(new WindowAdapter()
                    {
                        public void windowClosing(WindowEvent we)
                        {
                                GUIUtilities.saveGeometry(CopyDialog.this, 
                                    "jeditcom-copy-dialog");
                        }
                    });
               
                cpAction = new CopyAction();
        }
        
        class BrowseFileAction implements ActionListener
        {
                public void actionPerformed(ActionEvent e)
                {
                        JEditCommanderDirDialog dirDialog = new JEditCommanderDirDialog();
                        String fileStr = dirDialog.showDirDialog(System.getProperty("user.dir"));
                        
                        if (fileStr != null)
                            dirField.setText(fileStr);
                }
        }
        
        class CancelCopyAction implements ActionListener
        {
            public void actionPerformed(ActionEvent e)
            {
                dispose();
            }
        }
        
        class DoCopyAction implements ActionListener
        {
            public void actionPerformed(ActionEvent e)
            {
                Component parent = JEditCommanderPlugin.leftTable.getTopLevelAncestor();
                JEditCommanderFile[] files = JEditCommanderPlugin.leftTable.getTableModel(
                    ).getCurrentFiles();
                int[] selected = JEditCommanderPlugin.leftTable.getSelectedRows();
                File[] selFiles = new File[selected.length];
                
                for (int i = 0; i < selFiles.length; i++)
                {
                    selFiles[i] = files[selected[i]].getFile();
                }
                
                File destDir = new File(dirField.getText());
                cpAction.setParent(parent);
                cpAction.setSourceFile(selFiles);
                cpAction.setDestinationDir(destDir);
                cpAction.start();
                dispose();
            }
        }
}