import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import org.gjt.sp.jedit.*;

class CopyProgressDialog extends JEditCommanderDialog
{
    JProgressBar fileProgress;
    JProgressBar totalProgress;
    
    JLabel totalLabel;
    JLabel fileLabel;
    JButton cancelButton;
    
    public CopyProgressDialog()
    {
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        
        this.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                GUIUtilities.saveGeometry(CopyProgressDialog.this, 
                    "jeditcom-progress-dialog");
                //dispose();
            }
            
            public void windowClosed(WindowEvent e)
            {
                GUIUtilities.saveGeometry(CopyProgressDialog.this, 
                    "jeditcom-progress-dialog");
            }
        });
        
        this.setModal(false);
        this.setTitle("Copy in progress");
        
        fileProgress = new JProgressBar(0, 100);
        fileProgress.setValue(0);
        fileProgress.setStringPainted(true);
        
        totalProgress = new JProgressBar(0, 100);
        totalProgress.setValue(0);
        totalProgress.setStringPainted(true);
        
        this.getContentPane().setLayout(new BoxLayout(this.getContentPane(),
            BoxLayout.Y_AXIS));
        JPanel progressPane = new JPanel(new GridLayout(0, 1));
        
        JPanel totalPane = new JPanel();
        totalPane.setLayout(new BoxLayout(totalPane, 
            BoxLayout.Y_AXIS));
        totalPane.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createLineBorder(Color.black), "Total progress"));
        totalLabel = new JLabel("Total progress");
        totalPane.add(totalLabel);
        totalPane.add(totalProgress);
        progressPane.add(totalPane);
        
        JPanel filePane = new JPanel();
        filePane.setLayout(new BoxLayout(filePane, 
            BoxLayout.Y_AXIS));
        filePane.setBorder(BorderFactory.createTitledBorder(
            BorderFactory.createLineBorder(Color.black), "File progress"));
        fileLabel = new JLabel("File progress");
        filePane.add(fileLabel);
        filePane.add(fileProgress);
        progressPane.add(filePane);
        
        this.getContentPane().add(progressPane);
        
        JPanel buttonPane = new JPanel();
        cancelButton = new JButton("Cancel");
        buttonPane.add(cancelButton);
        this.getContentPane().add(buttonPane);
        
        this.pack();
        GUIUtilities.loadGeometry(this, "jeditcom-progress-dialog");
    }
    
    public void setFileLabelText(String text)
    {
        fileLabel.setText(text);
    }
    
    public void setTotalLabelText(String text)
    {
        totalLabel.setText(text);
    }
    
    public void setTotalProgress(int value)
    {
        this.totalProgress.setValue(value);
    }
    
    public void setFileProgress(int value)
    {
        this.fileProgress.setValue(value);
    }
}