import java.io.*;
import org.gjt.sp.jedit.*;
import org.gjt.sp.util.*;
import javax.swing.*;
import java.awt.event.*;

class DeleteAction extends Thread
{
    File[] files;
    
    public DeleteAction()
    {
        super("jeditcom-delete-thread");
        files = null;
    }
    
    public DeleteAction(File[] filesToDelete)
    {
        super("jeditcom-delete-thread");
        this.files = filesToDelete;
    }
    
    public void setFiles(File[] filesToDelete)
    {
        this.files = filesToDelete;
    }
    
    public void run()
    {
        Log.log(Log.DEBUG, null, this.getName() + " started.");
        delete(files);
        this.yield();
        Log.log(Log.DEBUG, null, this.getName() + " yielded.");
    }
    
    public boolean delete(File[] filesToDelete)
    {
        boolean success = false;
        Log.log(Log.DEBUG, null, "Delete action requested");
        
        ProgressMonitor pMonitor = new ProgressMonitor(
            JEditCommanderPlugin.leftTable.getTopLevelAncestor(), "Deleting files....",
            "", 0, 100);
        pMonitor.setMillisToDecideToPopup(1000);
        
        for (int i = 0; i < filesToDelete.length; i++)
        {
            pMonitor.setNote("Deleting " + filesToDelete[i].getName() + "...");
            success = filesToDelete[i].delete();
            if (!success && filesToDelete[i].isDirectory())
            {
                Log.log(Log.MESSAGE, null, "Directory " + filesToDelete[i].getPath() +
                    " has not been deleted. Possible reason: directory not empty");
                pMonitor.setProgress((int) ((float) i / (float) filesToDelete.length));
            }
            else if (success == false)
            {
                String[] args = {filesToDelete[i].getPath()};
                GUIUtilities.error(JEditCommanderPlugin.leftTable.getTopLevelAncestor(),
                    "jeditcom.delete.failed", args);
                return false;
            }
            
            if (pMonitor.isCanceled() == true)
            {
                Log.log(Log.MESSAGE, null, "[jeditcom] Delete canceled by user");
                return false;
            }
        }
        
        if (success == true)
            JEditCommanderActions.refresh.actionPerformed(new ActionEvent(this, 
                ActionEvent.ACTION_LAST+1, "refresh"));
        else
            Log.log(Log.DEBUG, null, "[jeditcom] Delete failed");
        
        return success;
    }
        
}