import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import java.io.*;
import org.gjt.sp.util.*;

class DeleteButtonPressedAction implements ActionListener
{  
    DeleteAction delAction = new DeleteAction();
    
    public void actionPerformed(ActionEvent e)
    {
        JEditCommanderTable table = JEditCommanderPlugin.leftTable;
        JEditCommanderTableModel model = table.getTableModel();
        JEditCommanderFile[] files = model.getCurrentFiles();
        int[] selected = table.getSelectedRows();
        
        if (selected.length < 1)
        {
            Toolkit.getDefaultToolkit().beep();
            return;
        }
        
        int retValue = JOptionPane.showConfirmDialog(
            JEditCommanderPlugin.leftTable.getTopLevelAncestor(), 
            "Are you sure you want to delete selected files?", "Confirm Deletion",
            JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        
        if (retValue == JOptionPane.NO_OPTION)
        {
            Log.log(Log.DEBUG, null, "[jeditcom] Delete canceled");
            return;
        }
        
        File[] filesToDelete = new File[selected.length];
        for (int i = 0; i < selected.length; i++)
        {
            filesToDelete[i] = files[selected[i]].getFile();
            Log.log(Log.DEBUG, null, "File " + filesToDelete[i] + " scheduled for deletion");
        }
        
        Log.log(Log.DEBUG, null, "[jeditcom] Setting files for deletion...");
        delAction.setFiles(filesToDelete);
        Log.log(Log.DEBUG, null, "[jeditcom] Trying to start deletion thread...");
        delAction.run();
    }
}