import java.awt.event.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import org.gjt.sp.jedit.*;
import org.gjt.sp.util.*;

class DeselectByFilterAction implements ActionListener
{
    public void actionPerformed(final java.awt.event.ActionEvent e)
    {
        String input = null;
        Vector indicesToSelect = new Vector();
        JEditCommanderTable table = JEditCommanderPlugin.leftTable;
        JEditCommanderFile[] files = table.getTableModel().getCurrentFiles();
        
        if (table.getSelectedRowCount() < 1)
        {
            Toolkit.getDefaultToolkit().beep();
            return;
        }
        
        input = GUIUtilities.input(JEditCommanderPlugin.leftTable.getTopLevelAncestor(), 
            "jeditcom.deselectbyfilter", "*"); 
        
        if (input == null)
        {
            Toolkit.getDefaultToolkit().beep();
            return;
        }
        
        if (input.trim().equals("*"))
        {
            JEditCommanderActions.deselectAll.actionPerformed(e);
            return;
        }
        
        boolean wildFirst = false;
        if (input.charAt(0) == '*')
            wildFirst = true;
        
        StringTokenizer st = new StringTokenizer(input, "*");
        if (st.countTokens() > 2)
        {
            Toolkit.getDefaultToolkit().beep();
            GUIUtilities.error(JEditCommanderPlugin.leftTable.getTopLevelAncestor(),
                "jeditcom.selectbyfilter.toomany", null);
        }
        
        int ctToken = 0;
        String prefix = null;
        String suffix = null;
        while (st.hasMoreTokens() && ctToken < 3)
        {
            ctToken++;
            if (ctToken == 1 && !wildFirst)
                prefix = st.nextToken();
            else if (ctToken == 2)
                suffix = st.nextToken();
            else if (ctToken == 1 && wildFirst == true)
                suffix = st.nextToken();
        }
        
        Log.log(Log.DEBUG, null, "[jeditcom] Prefix: " + prefix);
        Log.log(Log.DEBUG, null, "[jeditcom] Suffix: " + suffix);
        
        for (int i = 0; i < files.length; i++)
        {
            String name = files[i].getFileName();
            
            if (ctToken == 1)
            {
                if (wildFirst == false)
                {
                    if (name.startsWith(prefix) == true)
                        indicesToSelect.addElement(new Integer(i));
                    else
                        continue;
                }
                else if (wildFirst == true)
                {
                    if (name.endsWith(suffix) == true)
                        indicesToSelect.addElement(new Integer(i));
                    else
                        continue;
                }
            }
            else if (ctToken == 2)
            {
                //Log.log(Log.DEBUG, null, "[jeditcom] PREFIX and SUFFIX");
                if (name.startsWith(prefix) && name.endsWith(suffix))
                    indicesToSelect.addElement(new Integer(i));
                else
                    continue;
            }
        } //for
        
        if (indicesToSelect.size() < 1)
        {
            Log.log(Log.MESSAGE, null, "[jeditcom] Nothing to deselect");
            return;
        }
        
        for (int i = 0; i < indicesToSelect.size(); i++)
        {
            int index = ((Integer) indicesToSelect.elementAt(i)).intValue();
            Log.log(Log.DEBUG, null, "[jeditcom] Deselect file: " +
                files[index].getFileName());
            ListSelectionModel selModel = table.getSelectionModel();
            if (table.isRowSelected(index) == true)
                selModel.removeSelectionInterval(index, index);
        }
    }
}