import java.awt.event.*;
import java.awt.*;
import org.gjt.sp.jedit.*;

class EditInBufferAction implements ActionListener
{
  
  private JEditCommanderTable table;
  
  public EditInBufferAction()
  {
    this.table = null;
  }
  
  public EditInBufferAction(JEditCommanderTable t)
  {
    this.table = t;
  }

  /** Opens selected files in jEdit (using the first view).
   * If the selected file happens to be a directory, it gets skipped.
   * @param event The ActionEvent which was sent to the function
   */
  public void actionPerformed(ActionEvent event) 
  {
    View theView = jEdit.getFirstView();
    JEditCommanderTableModel model = table.getTableModel();
    JEditCommanderFile[] currentFiles = model.getCurrentFiles();

    int[] selected = table.getSelectedRows();
    if (selected.length < 1)
    {
      Toolkit.getDefaultToolkit().beep();
      return;
    }
    
    boolean hasFile = false;
    for (int i = 0; i < selected.length; i++)
    {
      if (!currentFiles[selected[i]].getFile().isDirectory())
      {
        hasFile = true;
        break;
      }
    }
    
    if (!hasFile)
    {
      Toolkit.getDefaultToolkit().beep();
      return;
    }

    for (int i = 0; i < selected.length; i++)
    {
      String path = currentFiles[selected[i]].getFilePath();
      if (currentFiles[selected[i]].getFile().isDirectory())
        continue;

      jEdit.openFile(theView, path);
    }
  }
  
  public JEditCommanderTable getTable()
  {
    return this.table;
  }
  
  public void setTable(JEditCommanderTable t)
  {
    this.table = t;
  }
}