import java.awt.event.*;
import java.awt.*;
import org.gjt.sp.jedit.*;

/** The action handler of this files creates a new view and opens the
 * selected files in it. If the file happens to be a directory, it gets
 * ignored.
 */
class EditInNewViewAction implements ActionListener 
{
  private JEditCommanderTable table;

  public EditInNewViewAction() 
  {
    table = null;
  }

  public EditInNewViewAction(JEditCommanderTable t) 
  {
    this.table = t;
  }

  public void actionPerformed(ActionEvent e) 
  {
    View theView = jEdit.getFirstView();
    JEditCommanderTableModel model = table.getTableModel();
    JEditCommanderFile[] currentFiles = model.getCurrentFiles();

    int[] selected = table.getSelectedRows();
    if (selected.length < 1)
    {
      Toolkit.getDefaultToolkit().beep();
      return;
    }
    
    boolean hasFile = false;
    for (int i = 0; i < selected.length; i++)
    {
      if (!currentFiles[selected[i]].getFile().isDirectory())
      {
        hasFile = true;
        break;
      }
    }
    
    if (!hasFile)
    {
      Toolkit.getDefaultToolkit().beep();
      return;
    }

    View newView = jEdit.newView(theView, null);

    for (int i = 0; i < selected.length; i++)
    {
      String path = currentFiles[selected[i]].getFilePath();
      if (currentFiles[selected[i]].getFile().isDirectory())
      continue;

      Buffer newBuffer = jEdit.openFile(newView, path);
    }
  }

  public JEditCommanderTable getTable() 
  {
    return this.table;
  }

  public void setTable(JEditCommanderTable t) 
  {
    this.table = t;
  }
}