/*
 * FileInfoAction.java
 *
 * Created on Torek, 2000, junij 13, 12:15
 */

import java.io.*;
import java.awt.event.*;
import org.gjt.sp.jedit.*;
import org.gjt.sp.util.*;
import javax.swing.text.*;
import java.util.*;
import java.text.*;
import java.net.*;

/**
 *
 * @author  Matija Kejzar
 */
class FileInfoAction implements ActionListener
{
  private File theFile;

  /** Creates new FileInfoAction */
  public FileInfoAction()
  {
    this.theFile = null;
  }

  public FileInfoAction(File file)
  {
    this.theFile = file;
  }

  public void actionPerformed(final java.awt.event.ActionEvent e)
  {
    try
    {
      Buffer tempBuffer = null;
      org.gjt.sp.jedit.View view = jEdit.getFirstView();
      String parentFile = (new File(System.getProperty("user.home"))).getParent();
      String bufferFile = (new File(System.getProperty("user.home"))).getPath(
        ) + System.getProperty("file.separator") + theFile.getName() + " Info";

      Log.log(Log.DEBUG, null, "[JEDIT COMMANDER] bufferFile: " + bufferFile);

      Buffer infoBuffer = jEdit.openTemporary(view, parentFile, bufferFile,
        false, true);
      jEdit.commitTemporary(infoBuffer);

      StringBuffer infoStrBuffer = new StringBuffer("");
      String infoText = "";


      infoStrBuffer.append("File: " + theFile.getName() + "\n");
      infoStrBuffer.append("File parent directory: " + theFile.getParent() +
        "\n");

      try
      {
        infoStrBuffer.append("File URL: " + theFile.toURL().toString() + "\n");
      }
      catch (MalformedURLException muex)
      {
      }

      infoStrBuffer.append("File size: " + String.valueOf(theFile.length()) +
        " bytes\n");

      DateFormat dateFormat = DateFormat.getDateTimeInstance();
      long lastMod = theFile.lastModified();
      Date d = new Date(lastMod);
      infoStrBuffer.append("Last modified: " + dateFormat.format(d) + "\n");

      infoStrBuffer.append("Is directory: " + String.valueOf(theFile.isDirectory()) +
        "\n");

      infoStrBuffer.append("Can read: " + String.valueOf(theFile.canRead()) +
        "\n");
      infoStrBuffer.append("Can write: " + String.valueOf(theFile.canWrite()) +
        "\n");
      infoStrBuffer.append("Is hidden: " + String.valueOf(theFile.isHidden()));

      if (theFile.isDirectory())
      {
        infoStrBuffer.append("\n\n");
        infoStrBuffer.append("Listing of the directory contents:\n");
        File[] files = theFile.listFiles();

        for (int i = 0; i < files.length; i++)
          infoStrBuffer.append(files[i].getName() + "\n");
      }

      try
      {
        infoText = infoStrBuffer.toString();
        infoBuffer.insertString(0, infoText, null);
      }
      catch (BadLocationException blex)
      {
        blex.printStackTrace();
        return;
      }
    }
    catch (NullPointerException npex)
    {
      return;
    }
  }

  public static String getFileInfo(File file)
  {
    StringBuffer infoBuffer = new StringBuffer();

    if (JEditCommanderFileHandler.isRoot(file) == true)
       infoBuffer.append("File name: " + file.getPath() + "\n"); 
    else
        infoBuffer.append("File name: " + file.getName() + "\n");
    int lengthOfFirst = infoBuffer.length();
    for (int i = 0; i < lengthOfFirst; i++)
        infoBuffer.append("-");
    infoBuffer.append("\n");

    if (JEditCommanderFileHandler.isRoot(file) == true)
        infoBuffer.append("[ROOT FILESYSTEM]\n");
    else
        infoBuffer.append("Resides in directory: " + file.getParent() + "\n");
    infoBuffer.append("Last modified: " + getFormattedDate(file) + "\n");
    infoBuffer.append("Size: " + file.length() + " bytes\n");
    infoBuffer.append("Is directory: " + String.valueOf(file.isDirectory()) + "\n");
    infoBuffer.append("Is hidden: " + String.valueOf(file.isHidden()) + "\n");
    infoBuffer.append("Read access: " + String.valueOf(file.canRead()) + "\n");
    infoBuffer.append("Write access: " + String.valueOf(file.canWrite()));

    return infoBuffer.toString();
  }

  public File getFile()
  {
    return this.theFile;
  }

  public void setFile(File file)
  {
    this.theFile = file;
  }

    public static String getFormattedDate(File file)
    {
        String formatted = null;
        DateFormat dateFormat = DateFormat.getDateTimeInstance();
        long lastMod = file.lastModified();
        Date d = new Date(lastMod);
        formatted = dateFormat.format(d);
        
        return formatted;
    }
}