import javax.swing.*;
import org.gjt.sp.jedit.*;
import java.awt.event.*;

class FilteringEnabledCheckBox extends JCheckBox
{
    public FilteringEnabledCheckBox()
    {
        super("Filtering", jEdit.getBooleanProperty("jeditcom.filtering.enabled"));
        this.addItemListener(new FilterCheckListener());
    }
    
    class FilterCheckListener implements ItemListener
    {
        public void itemStateChanged(ItemEvent ie)
        {
            if (ie.getStateChange() == ItemEvent.SELECTED)
            {
                FileFiltering.filteringEnabled = true;
                JEditCommanderToolBar.filterBox.setEnabled(true);
                jEdit.setBooleanProperty("jeditcom.filtering.enabled", true);
            }
            else if (ie.getStateChange() == ItemEvent.DESELECTED)
            {
                FileFiltering.filteringEnabled = false;
                JEditCommanderToolBar.filterBox.setEnabled(false);
                jEdit.setBooleanProperty("jeditcom.filtering.enabled", false);
            }
            
            JEditCommanderActions.refresh.actionPerformed(new ActionEvent(
                FilteringEnabledCheckBox.this, ActionEvent.ACTION_LAST+1, "Refresh"));
        }
    }
}
