import java.io.*;
import java.util.*;
import java.text.DateFormat;

class JEditCommanderFile implements Comparable
{	
	private File file;
	private String name;
	private String path;
	private long size;
	private Date date;
        String dateStr;
        String timeStr;
        boolean isDir;
        boolean isHidden;
	
	public JEditCommanderFile()
	{
		file = null;
		name = null;
		path = null;
		size = 0;
		date = null;
                dateStr = null;
                timeStr = null;
                isDir = false;
                isHidden = false;
	}
	
	public JEditCommanderFile(File file)
	{
		this.file = file;
		this.name = file.getName();
		this.path = file.getPath();
		this.size = file.length();
		this.date = new Date(file.lastModified());
                DateFormat dfDate = DateFormat.getDateInstance();
                this.dateStr = dfDate.format(date);
                DateFormat dfTime = DateFormat.getTimeInstance();
                this.timeStr = dfTime.format(date);
                isDir = file.isDirectory();
                isHidden = file.isHidden();
	}
	
	public JEditCommanderFile(String path)
	{
		File newFile = new File(path);
		this.file = newFile;
		this.path = newFile.getPath();
		this.name = newFile.getName();
		this.size = newFile.length();
		this.date = new Date(newFile.lastModified());
                DateFormat dfDate = DateFormat.getDateInstance();
                this.dateStr = dfDate.format(date);
                DateFormat dfTime = DateFormat.getTimeInstance();
                this.timeStr = dfTime.format(date);
                isDir = file.isDirectory();
                isHidden = file.isHidden();
	}
	
	//--------------Accessors---------------------------
	public File getFile()
	{
		return this.file;
	}
	
	public String getFileName()
	{
		return this.name;
	}
	
	public String getFilePath()
	{
		return this.path;
	}
	
	public long getFileSize()
	{
		return this.size;
	}
	
	public Date getFileDate()
	{
		return this.date;
	}
	
	//-------------Modifiers--------------------
	public void setFile(File file)
	{
		this.file = file;
	}
	
	public void setFileName(String name)
	{
		this.name = name;
	}
	
	public void setFilePath(String path)
	{
		this.path = path;
	}
	
	public void setFileSize(long size)
	{
		this.size = size;
	}
	
	public void setFileDate(Date date)
	{
		this.date = date;
	}
	
	public String toString()
	{
		return this.name;
	}
	
	
	/**
	 * As specified by java.lang.Comparable interface
	 */
	 public int compareTo(Object other)
	 {
		JEditCommanderFile otherFile = (JEditCommanderFile) other;
		
		String thisName = name;
		String otherName = otherFile.getFileName();
		
		switch (JEditCommanderFileHandler.sortType)
		{
			case 0:
				return (thisName.compareTo(otherName));
			case 1:
				boolean thisIsDir = this.isDir;
				boolean otherIsDir = otherFile.isDir;
				if (thisIsDir == true && otherIsDir == false)
					return -1;
				else if (thisIsDir == otherIsDir)	
					return (thisName.compareTo(otherName));
				else
					return 1;
			case 2:
				if (this.getFileSize() < otherFile.getFileSize())
					return -1;
				else if (this.getFileSize() == otherFile.getFileSize())
					return 0;
				else
					return 1;
                        case 3:
                          if (date.before(otherFile.getFileDate()) == true)
                            return -1;
                          else
                            return 1;
                        case 4:
                          return 0;
			default:
				return 0;
		}	
		
	 }
}