import java.io.*;
import java.util.*;
import org.gjt.sp.util.*;

class JEditCommanderFileHandler
{	
	/**
	 * Determines what kind of sort type to use.
	 * Values are as follows:
	 * -1 - no sort (proabobly sorts files alphabetically)
	 * 0 - by name (alphabetically, no need to use proabobly)
	 * 1 - by type
	 * 2 - by size
	 * 3 - by date
	 */
	public static int sortType = -1;
	
	public static JEditCommanderFile[] getFiles(File directory)
	{
		if (!directory.isDirectory())
			return null;
		
		File[] files = directory.listFiles();
		JEditCommanderFile[] commanderFiles = new JEditCommanderFile[files.length];
		
		for (int i = 0; i < commanderFiles.length; i++)
		{
			commanderFiles[i] = new JEditCommanderFile(files[i]);
		}
		
		return commanderFiles;
	}
	
	/**
	 * Sorts the array according to the value of
	 * JEditCommanderFileHandler.sortType variable
	 */
	public static void sort(JEditCommanderFile[] files)
	{
		Log.log(Log.DEBUG, null, "Sorting required (type " + sortType + ")");
		Arrays.sort(files);
	}
	
	/**
	 * Returns true if the file specified as
	 * a paremeter is a root file (directory)
	 */
	public static boolean isRoot(File file)
	{
		File[] allRoots = File.listRoots();
		
		for (int i = 0; i < allRoots.length; i++)
		{
			if (allRoots[i].compareTo(file) == 0)
				return true;
		}
		
		return false;	
	}
	
	/**
	 * Transforms the File[] array into JEditCommanderFile[]
	 * array
	 */
	public static JEditCommanderFile[] transformToCommanderFiles(File[] files)
	{
		JEditCommanderFile[] commanderFiles = new JEditCommanderFile[files.length];
		
		for (int i = 0; i < files.length; i++)
			commanderFiles[i] = new JEditCommanderFile(files[i]);
		
		return commanderFiles;	
	}
}