import java.util.*;
import java.awt.event.*;
import org.gjt.sp.jedit.*;
import org.gjt.sp.jedit.msg.*;
import org.gjt.sp.util.*;
import org.gjt.sp.jedit.gui.*;
import java.io.*;

public class JEditCommanderPlugin extends EBPlugin
{
	public static File leftDirectory;

        public static JEditCommanderTable leftTable;

        public static int selected = -1;

	public JEditCommanderPlugin()
	{
		JEditCommanderFileHandler.sortType = Integer.parseInt(
			jEdit.getProperty("JEditCommander.initial.file.sort"));
	}

	public void start()
	{
		 jEdit.addAction(new launch_jedit_commander());
	}

	public void createMenuItems(View view, Vector menus, Vector menuItems)
        {
		menuItems.addElement(GUIUtilities.loadMenuItem(view,
			"launch_jedit_commander"));
        }
        
        public void createOptionPanes(OptionsDialog optionsDialog)
        {
            optionsDialog.addOptionPane(new JEditcomOptionPane());
        }

        /**
         * If a new Buffer has been created or if a Buffer has been
         * saved and if the parent directory of a Buffer is the same
         * directory that is currently being displayes in jEdit
         * Commander, then this method rescans and redisplays the
         * Buffer's parent directory<br>
         *
         * Secondly, if the editor is about to exit this method
         * calls a method to save jEditCommander's properties etc.
         */
        public void handleMessage(EBMessage msg)
        {
          if (msg instanceof BufferUpdate)
          {
            BufferUpdate bu = (BufferUpdate) msg;
            Buffer buffer = bu.getBuffer();
            if (buffer.getFile() == null)
              return;

            if (bu.getWhat() == BufferUpdate.CREATED || bu.getWhat() ==
              BufferUpdate.DIRTY_CHANGED)
            {
              Log.log(Log.DEBUG, null, "[JEDIT COMMANDER] BufferUpdate.CREATED "
                + "or BufferUpdate.DIRTY_CHANGED received");
              File parent = null;
              try
              {
                parent = buffer.getFile().getParentFile();
              }
              catch (NullPointerException npex)
              {
                return;
              }

              if (parent.equals(leftDirectory))
              {
                JEditCommanderActions.refresh.actionPerformed(
                  new ActionEvent(buffer, ActionEvent.ACTION_LAST + 1, "Refresh"));
              }
            } // if getWhat()
          } // if instanceof BufferUpdate

          if (msg instanceof EditorExiting)
          {
            try
            {
                JEditCommanderActions.quit.actionPerformed(new ActionEvent(this, 
                    ActionEvent.ACTION_LAST + 1, "Quit"));
            }
            catch (NullPointerException npe)
            {
                // Do nothing
            }
          } // editor exiting
        } // handleMessage
}
