import javax.swing.*;
import java.awt.*;

public class JEditCommanderSplitPane extends JSplitPane
{
	private JScrollPane leftScrollPane;
	private JScrollPane rightScrollPane;

	private JEditCommanderTable leftTable;

	private JPanel leftPanel;
	private JPanel rightPanel;

	private JEditCommanderInfoPane leftInfoPane;


	private JEditCommanderToolBar leftToolBar;

	public static JTextField leftDirField;

	public static int LEFT_TABLE = 0;
	public static int RIGHT_TABLE = 1;

        public static JEditCommanderInfoBox theBox;

	public JEditCommanderSplitPane()
	{
		// Add left
		leftPanel = new JPanel();
		leftPanel.setLayout(new BorderLayout());

		leftToolBar = new JEditCommanderToolBar();
		leftPanel.add(leftToolBar, BorderLayout.NORTH);

		leftTable = new JEditCommanderTable();
		leftScrollPane = new JScrollPane(leftTable);
		leftPanel.add(leftScrollPane, BorderLayout.CENTER);

		leftInfoPane = new JEditCommanderInfoPane();
		JEditCommanderSplitPane.leftDirField = leftInfoPane.getDirectoryField();
		leftPanel.add(leftInfoPane, BorderLayout.SOUTH);

		setLeftComponent(leftPanel);

		// Add right
		rightPanel = new JPanel();
		rightPanel.setLayout(new BorderLayout());
                theBox = new JEditCommanderInfoBox();
                rightScrollPane = new JScrollPane(theBox);
                rightPanel.add(rightScrollPane, BorderLayout.CENTER);
                setRightComponent(rightPanel);

		setOneTouchExpandable(true);
		//setDividerSize(2);
	}

	/**
	 * Returns either left or right table of the
	 * split pane.
	 *
	 * @param leftOrRight should be either LEFT_TABLE
	 * or RIGHT_TABLE accordingly
	 *
	 * @throws IllegealArgumentException if the parameter
	 * fails to match either LEFT_TABLE or RIGHT_TABLE
	 */
	public JEditCommanderTable getTable(int leftOrRight)
		throws IllegalArgumentException
	{
		if (leftOrRight != LEFT_TABLE && leftOrRight != RIGHT_TABLE)
			throw new IllegalArgumentException("Illegal table index");

		if (leftOrRight == LEFT_TABLE)
			return this.leftTable;
		else if (leftOrRight == RIGHT_TABLE)
			return null;

		return null;
	}

}