import java.util.*;
import javax.swing.table.*;
import java.io.*;
import java.text.*;

class JEditCommanderTableModel extends AbstractTableModel
{
	private String[] columnNames = {"Name", "Size", "Date", "Time"};
	private JEditCommanderFile[] currentFiles;

	public JEditCommanderTableModel()
	{
		currentFiles = null;
	}

	public JEditCommanderTableModel(File initialDir)
	{
		currentFiles = JEditCommanderFileHandler.getFiles(initialDir);
		JEditCommanderFileHandler.sort(currentFiles);
	}

	public JEditCommanderTableModel(String initialDir)
	{
		currentFiles = JEditCommanderFileHandler.getFiles(new File(initialDir));
		JEditCommanderFileHandler.sort(currentFiles);
	}

	public Object getValueAt(int row, int column)
	{
		switch (column)
		{
			case 0:
				if (JEditCommanderFileHandler.isRoot(currentFiles[row].getFile()))
					return currentFiles[row].getFilePath();
				return currentFiles[row].getFileName(); // String
			case 1:
				return (new Long(currentFiles[row].getFileSize()));
			case 2:
				String dateString = currentFiles[row].dateStr;
				return dateString;
			case 3:
				String timeString = currentFiles[row].timeStr;
				return timeString;
			default:
				return currentFiles[row];
		}
	}

	public String getColumnName(int column)
	{
		return columnNames[column];
	}

	public int getColumnCount()
	{
		return columnNames.length;
	}

	public int getRowCount()
	{
		if (currentFiles == null)
			return 0;

		return currentFiles.length;
	}

	public Class getColumnClass(int c)
	{
		return (getValueAt(0, c).getClass());
    }

	/*public void setValueAt(Object value, int row, int column)
	{
		fireTableCellUpdated(row, column);
	}*/

	public boolean isCellEditable(int row, int column)
	{
		return false;
	}



	public JEditCommanderFile[] getCurrentFiles()
	{
		return this.currentFiles;
	}

	public void setCurrentFiles(JEditCommanderFile[] files)
	{
		this.currentFiles = files;
	}
}