import javax.swing.*;
import java.net.*;

class JEditCommanderToolBar extends JToolBar
{
	JButton directoryUpBtn;
	JButton toRootBtn;
	JButton refreshBtn;
        JButton selectAllButton;
        JButton selectFilterButton;
        JButton deselectAllButton;
        JButton deselectFilterButton;
        JButton invertSelectionButton;
        JButton goHomeButton;
        
        static RootSwitchBox rootSwitchBox;
        static FileFilterBox filterBox;
        FilteringEnabledCheckBox filterCheckBox;
        
        ImageIcon[] icons;
	
	public JEditCommanderToolBar()
	{
		icons = this.getIcons();
                setFloatable(false);
		
		directoryUpBtn = new JButton(icons[0]);
		directoryUpBtn.addActionListener(JEditCommanderActions.changeDir);
		directoryUpBtn.setToolTipText("Directory Up");
		add(directoryUpBtn);
		
		toRootBtn = new JButton(icons[1]);
		toRootBtn.addActionListener(JEditCommanderActions.toRoot);
		toRootBtn.setToolTipText("To Root");
		add(toRootBtn);
                
                goHomeButton = new JButton(icons[8]);
		goHomeButton.addActionListener(JEditCommanderActions.goHome);
		goHomeButton.setToolTipText("Change To Home Directory");
		add(goHomeButton);
		
		refreshBtn = new JButton(icons[2]);
		refreshBtn.addActionListener(JEditCommanderActions.refresh);
		refreshBtn.setToolTipText("Refresh");
		add(refreshBtn);
                
                this.addSeparator();
                rootSwitchBox = new RootSwitchBox();
                add(rootSwitchBox);
                filterBox = new FileFilterBox();
                add(filterBox);
                filterCheckBox = new FilteringEnabledCheckBox();
                add(filterCheckBox);
                
                this.addSeparator();
                selectAllButton = new JButton(icons[3]);
                selectAllButton.addActionListener(JEditCommanderActions.selectAll);
                selectAllButton.setToolTipText("Select All Files/Directories");
                add(selectAllButton);
                
                selectFilterButton = new JButton(icons[4]);
                selectFilterButton.addActionListener(JEditCommanderActions.selectFilter);
                selectFilterButton.setToolTipText("Select By Filter");
                add(selectFilterButton);
                
                deselectAllButton = new JButton(icons[5]);
                deselectAllButton.addActionListener(JEditCommanderActions.deselectAll);
                deselectAllButton.setToolTipText("Deselect All");
                add(deselectAllButton);
                
                deselectFilterButton = new JButton(icons[6]);
                deselectFilterButton.addActionListener(JEditCommanderActions.deselectFilter);
                deselectFilterButton.setToolTipText("Deselect By Filter");
                add(deselectFilterButton);
                
                invertSelectionButton = new JButton(icons[7]);
                invertSelectionButton.addActionListener(JEditCommanderActions.invert);
                invertSelectionButton.setToolTipText("Invert Selection");
                add(invertSelectionButton);
	}
        
        private ImageIcon[] getIcons()
        {
            ImageIcon[] iconArray = new ImageIcon[9];
            URL[] urlArray = new URL[iconArray.length];
            
            urlArray[0] = JEditCommanderToolBar.class.getResource("/icons/Up.gif");
            urlArray[1] = JEditCommanderToolBar.class.getResource("/icons/VCRFastForward.gif");
            urlArray[2] = JEditCommanderToolBar.class.getResource("/icons/CD.gif");
            urlArray[3] = JEditCommanderToolBar.class.getResource("/icons/PageSetup.gif");
            urlArray[4] = JEditCommanderToolBar.class.getResource("/icons/Plus.gif");
            urlArray[5] = JEditCommanderToolBar.class.getResource("/icons/Delete.gif");
            urlArray[6] = JEditCommanderToolBar.class.getResource("/icons/Minus.gif");
            urlArray[7] = JEditCommanderToolBar.class.getResource("/icons/DeleteRow.gif");
            urlArray[8] = JEditCommanderToolBar.class.getResource("/icons/Home.gif");
            
            for (int i = 0; i < iconArray.length; i++)
                iconArray[i] = new ImageIcon(urlArray[i]);
            
            return iconArray;
        }
}