import org.gjt.sp.jedit.*;
import javax.swing.*;
import java.io.*;
import java.awt.event.*;

public class JEditcomOptionPane extends AbstractOptionPane 
{
    JTextField startupDirField;
    JComboBox sortTypeBox;
    
    public JEditcomOptionPane()
    {
        super("jeditcom.options");
    }
    
    public void _init()
    {
        String initialDirStr = jEdit.getProperty("jeditcom.initial.dir");
        if (initialDirStr.equalsIgnoreCase("null") || initialDirStr.length() < 1)
            initialDirStr = System.getProperty("user.home");
        startupDirField = new JTextField(initialDirStr, 25);
        this.addComponent("Initial directory", startupDirField);
        
        String[] sortValues = {"-1) No sort", "0) By name", "1) By type", 
            "2) By size", "3) By date"};
        sortTypeBox = new JComboBox(sortValues);
        int selected = (Integer.valueOf(jEdit.getProperty("JEditCommander.initial.file.sort"))).intValue() 
            + 1;
        sortTypeBox.setSelectedIndex(selected);
        this.addComponent("Sort types", sortTypeBox);
    }
    
    public void _save()
    {
        if (startupDirField.getText().length() > 0)
        {
            File initFile = new File(startupDirField.getText().trim());
            if (initFile.exists() == true)
                jEdit.setProperty("jeditcom.initial.dir", startupDirField.getText().trim());
        }
        
        int newSort = sortTypeBox.getSelectedIndex() - 1;
        if (newSort != JEditCommanderFileHandler.sortType)
        {
            JEditCommanderFileHandler.sortType = newSort;
            JEditCommanderFileHandler.sort(JEditCommanderPlugin.leftTable.getTableModel().getCurrentFiles());
            JEditCommanderActions.refresh.actionPerformed(new ActionEvent(this,
                ActionEvent.ACTION_LAST, "Refresh"));
        }
    }
    
}