import org.gjt.sp.jedit.*;
import org.gjt.sp.util.*;
import java.io.*;
import java.awt.event.*;

class RenMovAction extends Thread
{
    private File[] toRename;
    private String[] newPath;
    
    public RenMovAction()
    {
        super("jeditcom-rename-thread");
        toRename = null;
        newPath = null;
    }
    
    public RenMovAction(File[] filesToRen, String[] path)
    {
        super("jeditcom-rename-thread");
        this.toRename = filesToRen;
        this.newPath = path;
    }
    
    public void setFiles(File[] files)
    {
        this.toRename = files;
    }
    
    public void setPath(String[] path)
    {
        this.newPath = path;
    }
    
    public void run()
    {
        boolean success = rename(toRename, newPath);
        if (!success)
        {
            GUIUtilities.error(JEditCommanderPlugin.leftTable.getTopLevelAncestor(), 
                "jeditcom.renmov.error", null);
        }
        else
            JEditCommanderActions.refresh.actionPerformed(new ActionEvent(
                this, ActionEvent.ACTION_LAST+1, "Refresh"));
        yield();
    }
    
    /**
     * Returns true if and only if all the files have
     * been successfully renamed.
     */
    public boolean rename(File[] files, String[] paths)
    {
        boolean success = false;
        boolean allSuccess = true;
        
        for (int i = 0; i < files.length; i++)
        {
            boolean hasSeparator = false;
            String separator = System.getProperty("file.separator");
            int sepSize = separator.length();
            
            for (int j = 0; j < paths[i].length(); j += sepSize)
            {
                String part = paths[i].substring(j, j+sepSize);
                Log.log(Log.DEBUG, null, "[jeditcom] Substring: " + part);
                if (part.equals(separator))
                {
                    hasSeparator = true;
                    break;
                }
            }
            
            String theRenPath = null;
            if (hasSeparator == true)
            {
                theRenPath = paths[i];
            }
            else
            {
                theRenPath = JEditCommanderPlugin.leftDirectory.getPath() + 
                    separator + paths[i];
            }
            
            Log.log(Log.DEBUG, null, "[jeditcom] Renaming file " + files[i].getPath() + 
                " to file " + theRenPath);
            
            success = files[i].renameTo(new File(theRenPath));
            if (!success)
            {
                Log.log(Log.ERROR, null, "[jeditcom] File " + files[i].getPath() + 
                    " could not be renamed to " + theRenPath);
                allSuccess = false;
            }
            else
            {
                Log.log(Log.MESSAGE, null, "[jeditcom] File " + files[i].getPath() +
                    " succesfully renamed to " + theRenPath);
            }
        }
        
        return allSuccess;
    }
    
}