import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import org.gjt.sp.jedit.*;
import org.gjt.sp.util.*;

class SelectBufferDialog extends JEditCommanderDialog implements ActionListener
{
  private JComboBox bufferBox;
  private Buffer[] buffers;
  
  public SelectBufferDialog()
  {
    this.setTitle("Buffer Selection");
    this.setModal(true);
    getContentPane().setLayout(new BorderLayout());
    
    buffers = jEdit.getBuffers();
    
    if (buffers.length > 0)
    {
      bufferBox = new JComboBox(buffers);
      bufferBox.setSelectedIndex(0);
      getContentPane().add(bufferBox, BorderLayout.CENTER);
      
      JButton okButton = new JButton("OK");
      okButton.addActionListener(this);
      JButton cancelButton = new JButton("Cancel");
      cancelButton.addActionListener(this);
      JPanel btnPane = new JPanel();
      btnPane.setLayout(new GridLayout(1, 0));
      btnPane.add(okButton);
      btnPane.add(cancelButton);
      getContentPane().add(btnPane, BorderLayout.SOUTH);
      
      JLabel dialogLbl = new JLabel("Select a buffer to append to: ");
      getContentPane().add(dialogLbl, BorderLayout.NORTH);
      
      this.pack();
      GUIUtilities.loadGeometry(this, "buffer-dialog");
      this.show();
    }
  }
  
  public void actionPerformed(final java.awt.event.ActionEvent p1)
  {
    JButton button = (JButton) p1.getSource();
    
    if (button.getText().equalsIgnoreCase("Cancel"))
    {
      this.dispose();
      return;
    }
    
    Log.log(Log.DEBUG, null, "Buffer append requested");
    int index = bufferBox.getSelectedIndex();
    Buffer[] bArray = jEdit.getBuffers();
    Buffer b = bArray[index];
    new AppendToBufferAction(JEditCommanderPlugin.leftTable, b, p1);
    this.dispose();
  }
  
  public void dispose()
  {
    GUIUtilities.saveGeometry(this, "buffer-dialog");
    super.dispose();
  }
}